diff --git a/krita/plugins/tools/defaulttools/kis_tool_ellipse.cc b/krita/plugins/tools/defaulttools/kis_tool_ellipse.cc
index 54d4148..78f40b1 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_ellipse.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_ellipse.cc
@@ -69,13 +69,12 @@ void KisToolEllipse::finishEllipse(const QRectF& rect)
         setupPainter(&painter);
         painter.setOpacity(m_opacity);
         painter.setCompositeOp(m_compositeOp);
-
         painter.paintEllipse(rect);
+        painter.endTransaction(image()->undoAdapter());
+
         QRegion bound = painter.dirtyRegion();
         device->setDirty(bound);
         notifyModified();
-
-        canvas()->addCommand(painter.endTransaction());
     } else {
         QRectF r = convertToPt(rect);
         KoShape* shape = KisShapeToolHelper::createEllipseShape(r);
diff --git a/krita/plugins/tools/defaulttools/kis_tool_fill.cc b/krita/plugins/tools/defaulttools/kis_tool_fill.cc
index d643fdd..507ace5 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_fill.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_fill.cc
@@ -140,7 +140,7 @@ bool KisToolFill::flood(int startX, int startY)
             ++it;
         }
 
-        canvas->addCommand(m_painter->endTransaction());
+        m_painter->endTransaction(image()->undoAdapter());
 
     } else {
 
@@ -162,8 +162,8 @@ bool KisToolFill::flood(int startX, int startY)
         else
             fillPainter.fillColor(startX, startY, currentImage()->mergedImage());
 
+        fillPainter.endTransaction(image()->undoAdapter());
         dirty = fillPainter.dirtyRegion();
-        canvas->addCommand(fillPainter.endTransaction());
     }
     device->setDirty(dirty);
     delete updater;
diff --git a/krita/plugins/tools/defaulttools/kis_tool_gradient.cc b/krita/plugins/tools/defaulttools/kis_tool_gradient.cc
index fc2f66d..9affbbd 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_gradient.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_gradient.cc
@@ -291,12 +291,12 @@ void KisToolGradient::mouseReleaseEvent(KoPointerEvent *e)
             painter.setProgress(updater->startSubtask());
 
             painter.paintGradient(m_startPos, m_endPos, m_shape, m_repeat, m_antiAliasThreshold, m_reverse, 0, 0, currentImage()->width(), currentImage()->height());
-            canvas->addCommand(painter.endTransaction());
+            painter.endTransaction(image()->undoAdapter());
 
             qApp->restoreOverrideCursor();
 #else
             // XXX: figure out why threaded gradients give weird noise
-            KisTransaction* transaction = new KisTransaction(i18n("Gradient"), device);
+            KisTransaction transaction(i18n("Gradient"), device);
 
             KisCanvas2 * canvas = dynamic_cast<KisCanvas2 *>(canvas());
             KoProgressUpdater * updater = canvas->view()->createProgressUpdater();
@@ -321,7 +321,7 @@ void KisToolGradient::mouseReleaseEvent(KoPointerEvent *e)
 
             applicator.execute();
 
-            canvas()->addCommand(transaction);
+            transaction.commit(image()->undoAdapter());
 #endif
             currentNode()->setDirty();
             notifyModified();
diff --git a/krita/plugins/tools/defaulttools/kis_tool_line.cc b/krita/plugins/tools/defaulttools/kis_tool_line.cc
index ddd0e90..acbb6df 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_line.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_line.cc
@@ -185,7 +185,7 @@ void KisToolLine::mouseReleaseEvent(KoPointerEvent *e)
                     notifyModified();
 
 
-                    canvas()->addCommand(m_painter->endTransaction());
+                    m_painter->endTransaction(image()->undoAdapter());
                     delete m_painter;
                     m_painter = 0;
                 }
diff --git a/krita/plugins/tools/defaulttools/kis_tool_move.cc b/krita/plugins/tools/defaulttools/kis_tool_move.cc
index bece05b..d4b4a0f 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_move.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_move.cc
@@ -149,9 +149,7 @@ void KisToolMove::mousePressEvent(KoPointerEvent *e)
             node = currentNode();
         }
 
-        if (currentImage()->undo()) {
-            currentImage()->undoAdapter()->beginMacro(i18n("Move"));
-        }
+        currentImage()->undoAdapter()->beginMacro(i18n("Move"));
 
         if (selection && !selection->isTotallyUnselected(image->bounds())) {
             //selection->convertToQImage(0).save("selection.png");
@@ -174,12 +172,15 @@ void KisToolMove::mousePressEvent(KoPointerEvent *e)
                 gc.bitBlt(rc.topLeft(), oldLayer->paintDevice(), rc);
                 gc.end();
 
-                // clear the old layer
-                currentImage()->undoAdapter()->addCommand(new KisTransaction("cut", oldLayer->paintDevice()));
-                oldLayer->paintDevice()->clearSelection(selection);
+                {
+                    KisTransaction transaction("cut", oldLayer->paintDevice());
+                    // clear the old layer
+                    oldLayer->paintDevice()->clearSelection(selection);
+                    transaction.commit(image->undoAdapter());
 
-                // deselect away the selection???
-                selection->clear();
+                    // deselect away the selection???
+                    selection->clear();
+                }
 
                 KisCanvas2* kisCanvas = dynamic_cast<KisCanvas2*>(canvas());
                 KisView2* view = 0;
diff --git a/krita/plugins/tools/defaulttools/kis_tool_path.cc b/krita/plugins/tools/defaulttools/kis_tool_path.cc
index 0e8b5b8..dc5ed16 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_path.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_path.cc
@@ -133,12 +133,12 @@ void KisToolPath::addPathShape(KoPathShape* pathShape)
         painter.setPaintOpPreset(preset, image);
 
         painter.paintPainterPath(mapedOutline);
+        painter.endTransaction(image->undoAdapter());
+
         QRegion dirtyRegion = painter.dirtyRegion();
         dev->setDirty(dirtyRegion);
         image->setModified();
 
-        kiscanvas->addCommand(painter.endTransaction());
-
     } else {
         pathShape->normalize();
         QUndoCommand * cmd = canvas()->shapeController()->addShape(pathShape);
diff --git a/krita/plugins/tools/defaulttools/kis_tool_rectangle.cc b/krita/plugins/tools/defaulttools/kis_tool_rectangle.cc
index 0359159..fe73757 100644
--- a/krita/plugins/tools/defaulttools/kis_tool_rectangle.cc
+++ b/krita/plugins/tools/defaulttools/kis_tool_rectangle.cc
@@ -81,13 +81,12 @@ void KisToolRectangle::finishRect(const QRectF &rect)
         setupPainter(&painter);
         painter.setOpacity(m_opacity);
         painter.setCompositeOp(m_compositeOp);
-
         painter.paintRect(rect);
+        painter.endTransaction(image()->undoAdapter());
+
         QRegion bound = painter.dirtyRegion();
         device->setDirty(bound);
         notifyModified();
-
-        canvas()->addCommand(painter.endTransaction());
     } else {
         QRectF r = convertToPt(rect);
         KoShape* shape = KisShapeToolHelper::createRectangleShape(r);
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_brush.cc b/krita/plugins/tools/selectiontools/kis_tool_select_brush.cc
index c580853..93703dd 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_brush.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_brush.cc
@@ -192,8 +192,7 @@ void KisToolSelectBrush::applyToSelection(const QPainterPath &selection) {
 
         painter.fillPainterPath(selection);
 
-        QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectAction);
-        canvas()->addCommand(cmd);
+        helper.selectPixelSelection(tmpSel, m_selectAction);
 
         resetSelection();
     }
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_contiguous.cc b/krita/plugins/tools/selectiontools/kis_tool_select_contiguous.cc
index 839f510..13716a8 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_contiguous.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_contiguous.cc
@@ -91,8 +91,7 @@ void KisToolSelectContiguous::mousePressEvent(KoPointerEvent * e)
             return;
 
         KisSelectionToolHelper helper(kisCanvas, currentNode(), i18n("Contiguous Area Selection"));
-        QUndoCommand* cmd = helper.selectPixelSelection(selection->pixelSelection(), m_selectAction);
-        canvas()->addCommand(cmd);
+        helper.selectPixelSelection(selection->pixelSelection(), m_selectAction);
 
         QApplication::restoreOverrideCursor();
     }
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_elliptical.cc b/krita/plugins/tools/selectiontools/kis_tool_select_elliptical.cc
index 3d564ee..5ffda5f 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_elliptical.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_elliptical.cc
@@ -43,7 +43,6 @@
 #include "kis_paintop_registry.h"
 #include "kis_layer.h"
 #include "kis_selection_options.h"
-#include "kis_selected_transaction.h"
 #include "canvas/kis_canvas2.h"
 #include "kis_pixel_selection.h"
 #include "kis_selection_tool_helper.h"
@@ -93,8 +92,7 @@ void KisToolSelectElliptical::LocalTool::finishEllipse(const QRectF &rect)
 
         painter.paintEllipse(rect);
 
-        QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
-        canvas()->addCommand(cmd);
+        helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
     } else {
         QRectF ptRect = convertToPt(rect);
         KoShape* shape = KisShapeToolHelper::createEllipseShape(ptRect);
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_magnetic.cc b/krita/plugins/tools/selectiontools/kis_tool_select_magnetic.cc
index fd43b0c..904bd63 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_magnetic.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_magnetic.cc
@@ -439,13 +439,14 @@ void KisToolSelectMagnetic::LocalTool::cleanDetectedBorder()
         QVector2D relativeVectorToAfterNext = QVector2D(afterNext)-QVector2D(current);
 
         qreal distToNext = relativeVectorToNext.length();
-        qreal distToAfterNext = relativeVectorToAfterNext.length();
+        // FIXME: seems to be unused!
+        //qreal distToAfterNext = relativeVectorToAfterNext.length();
 
         qreal angleToNext = std::atan2((qreal)relativeVectorToNext.y(), (qreal) relativeVectorToNext.x());
         qreal angleToAfterNext = std::atan2((qreal)relativeVectorToAfterNext.y(), (qreal) relativeVectorToAfterNext.x());
 
         if(fabs((angleToAfterNext-angleToNext)*distToNext)<1) {
-            qDebug()<<"dleting: "<<(angleToAfterNext-angleToNext)*distToNext;
+            qDebug()<<"deleting: "<<(angleToAfterNext-angleToNext)*distToNext;
             iter = detectedBorder.erase(iter);
         }
         else {
@@ -487,8 +488,7 @@ void KisToolSelectMagnetic::LocalTool::addPathShape(KoPathShape* pathShape)
 
     painter.paintPolygon(QPolygonF(m_detectedBorder));
 
-    QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
-    canvas()->addCommand(cmd);
+    helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
 
     m_detectedBorder.clear();
     m_tmpDetectedBorder.clear();
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_outline.cc b/krita/plugins/tools/selectiontools/kis_tool_select_outline.cc
index 6fe5805..56d9721 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_outline.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_outline.cc
@@ -45,7 +45,6 @@
 #include <kis_cursor.h>
 #include <kis_image.h>
 
-#include "kis_selected_transaction.h"
 #include "kis_painter.h"
 #include "kis_paintop_registry.h"
 #include "canvas/kis_canvas2.h"
@@ -128,8 +127,7 @@ void KisToolSelectOutline::mouseReleaseEvent(KoPointerEvent *event)
                 painter.setCompositeOp(tmpSel->colorSpace()->compositeOp(COMPOSITE_OVER));
                 painter.paintPolygon(m_points);
 
-                QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectAction);
-                canvas()->addCommand(cmd);
+                helper.selectPixelSelection(tmpSel, m_selectAction);
             } else {
 
                 KoPathShape* path = new KoPathShape();
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_path.cc b/krita/plugins/tools/selectiontools/kis_tool_select_path.cc
index 64e6c0a..df74a2d 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_path.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_path.cc
@@ -168,8 +168,7 @@ void KisToolSelectPath::LocalTool::addPathShape(KoPathShape* pathShape)
         matrix.translate(pathShape->position().x(), pathShape->position().y());
         painter.fillPainterPath(matrix.map(pathShape->outline()));
 
-        QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
-        canvas()->addCommand(cmd);
+        helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
 
         delete pathShape;
     } else {
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_polygonal.cc b/krita/plugins/tools/selectiontools/kis_tool_select_polygonal.cc
index adb1c8b..908cdd3 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_polygonal.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_polygonal.cc
@@ -97,8 +97,7 @@ void KisToolSelectPolygonal::LocalTool::finishPolyline(const QVector<QPointF> &p
         painter.setCompositeOp(tmpSel->colorSpace()->compositeOp(COMPOSITE_OVER));
         painter.paintPolygon(points);
 
-        QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
-        canvas()->addCommand(cmd);
+        helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
     } else {
         KoPathShape* path = new KoPathShape();
         path->setShapeId(KoPathShapeId);
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_rectangular.cc b/krita/plugins/tools/selectiontools/kis_tool_select_rectangular.cc
index d7143e3..90d4042 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_rectangular.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_rectangular.cc
@@ -90,8 +90,7 @@ void KisToolSelectRectangular::LocalTool::finishRect(const QRectF& rect)
             KisPixelSelectionSP tmpSel = KisPixelSelectionSP(new KisPixelSelection());
             tmpSel->select(rc);
 
-            QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
-            canvas()->addCommand(cmd);
+            helper.selectPixelSelection(tmpSel, m_selectingTool->m_selectAction);
         }
     } else {
         QRectF documentRect = convertToPt(rect);
diff --git a/krita/plugins/tools/selectiontools/kis_tool_select_similar.cc b/krita/plugins/tools/selectiontools/kis_tool_select_similar.cc
index b50628c..592b62d 100644
--- a/krita/plugins/tools/selectiontools/kis_tool_select_similar.cc
+++ b/krita/plugins/tools/selectiontools/kis_tool_select_similar.cc
@@ -44,7 +44,6 @@
 #include <kis_selection.h>
 #include <kis_paint_device.h>
 #include <kis_iterators_pixel.h>
-#include <kis_selected_transaction.h>
 #include "canvas/kis_canvas2.h"
 #include <kis_pixel_selection.h>
 #include "kis_selection_tool_helper.h"
@@ -128,9 +127,8 @@ void KisToolSelectSimilar::mousePressEvent(KoPointerEvent *e)
         selectByColor(dev, tmpSel, c.data(), m_fuzziness);
 
         KisSelectionToolHelper helper(kisCanvas, currentNode(), i18n("Similar Selection"));
-        QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, m_selectAction);
+        helper.selectPixelSelection(tmpSel, m_selectAction);
 
-        canvas()->addCommand(cmd);
         QApplication::restoreOverrideCursor();
     }
 }
diff --git a/krita/plugins/tools/tool_crop/kis_tool_crop.cc b/krita/plugins/tools/tool_crop/kis_tool_crop.cc
index 7999387..d0f919d 100644
--- a/krita/plugins/tools/tool_crop/kis_tool_crop.cc
+++ b/krita/plugins/tools/tool_crop/kis_tool_crop.cc
@@ -44,7 +44,6 @@
 #include <kis_image.h>
 #include <kis_undo_adapter.h>
 #include <KoPointerEvent.h>
-#include <kis_selected_transaction.h>
 #include <kis_selection.h>
 #include <kis_layer.h>
 #include <kis_crop_visitor.h>
@@ -442,15 +441,13 @@ void KisToolCrop::crop()
     if (m_optWidget->cmbType->currentIndex() == 0 && currentNode()->paintDevice()) {
         // The layer(s) under the current layer will take care of adding
         // undo information to the Crop macro.
-        if (currentImage()->undo())
-            currentImage()->undoAdapter()->beginMacro(i18n("Crop"));
+        currentImage()->undoAdapter()->beginMacro(i18n("Crop"));
 
         KisCropVisitor v(cropRect, false);
         KisNodeSP node = currentNode();
         node->accept(v);
 
-        if (currentImage()->undo())
-            currentImage()->undoAdapter()->endMacro();
+        currentImage()->undoAdapter()->endMacro();
 
     } else {
         // Resize creates the undo macro itself
diff --git a/krita/plugins/tools/tool_curves/kis_tool_curve.cc b/krita/plugins/tools/tool_curves/kis_tool_curve.cc
index 1377e46..c2a4ad5 100644
--- a/krita/plugins/tools/tool_curves/kis_tool_curve.cc
+++ b/krita/plugins/tools/tool_curves/kis_tool_curve.cc
@@ -428,7 +428,7 @@ void KisToolCurve::paintCurve()
     if (!device) return;
 
     KisPainter painter(device);
-    if (m_currentImage->undo()) painter.beginTransaction(m_transactionMessage);
+    painter.beginTransaction(m_transactionMessage);
     painter.setBounds(m_currentImage->bounds());
     painter.setPaintColor(m_subject->fgColor());
     painter.setBrush(m_subject->currentBrush());
@@ -446,9 +446,7 @@ void KisToolCurve::paintCurve()
     device->setDirty(painter.dirtyRegion());
     notifyModified();
 
-    if (m_currentImage->undo()) {
-        m_currentImage->undoAdapter()->addCommandOld(painter.endTransaction());
-    }
+    m_currentImage->undoAdapter()->addCommandOld(painter.endTransaction());
 
     draw(false);
 }
@@ -489,8 +487,8 @@ void KisToolCurve::selectCurve()
     QApplication::setOverrideCursor(KisCursor::waitCursor());
     KisPaintDeviceSP dev = currentNode()->paintDevice();
     bool hasSelection = dev->hasSelection();
-    KisSelectedTransaction *t = 0;
-    if (m_currentImage->undo() && hasSelection) t = new KisSelectedTransaction(m_transactionMessage, dev);
+    KisSelectedTransaction *transaction = 0;
+    if (hasSelection) transaction = new KisSelectedTransaction(m_transactionMessage, currentNode());
     KisSelectionSP selection = dev->selection();
 
     if (!hasSelection) {
@@ -527,10 +525,11 @@ void KisToolCurve::selectCurve()
     } else {
         dev->setDirty();
     }
-    /*
-        if (m_currentImage->undo())
-            m_currentImage->undoAdapter()->addCommandOld(t);
-    */
+
+    if (transaction) {
+        transaction->commit(m_currentImage->undoAdapter());
+        delete transaction;
+    }
     QApplication::restoreOverrideCursor();
 
     draw(false);
diff --git a/krita/plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc b/krita/plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc
index fc45e68..74bac41 100644
--- a/krita/plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc
+++ b/krita/plugins/tools/tool_perspectivegrid/kis_tool_perspectivegrid.cc
@@ -39,7 +39,6 @@
 #include <KoViewConverter.h>
 #include <canvas/kis_perspective_grid_manager.h>
 #include <kis_canvas_resource_provider.h>
-#include <kis_selected_transaction.h>
 #include <kis_painter.h>
 #include <kis_paintop_registry.h>
 #include <kis_view2.h>
diff --git a/krita/plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc b/krita/plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc
index 9e595f2..0fbeceb 100644
--- a/krita/plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc
+++ b/krita/plugins/tools/tool_perspectivetransform/kis_tool_perspectivetransform.cc
@@ -53,7 +53,7 @@
 #include <kis_cursor.h>
 #include <kis_image.h>
 #include <kis_undo_adapter.h>
-#include <kis_selected_transaction.h>
+#include <kis_transaction.h>
 #include <kis_selection.h>
 #include <kis_filter_strategy.h>
 #include <kis_perspectivetransform_worker.h>
@@ -63,11 +63,11 @@
 
 namespace
 {
-class PerspectiveTransformCmd : public KisSelectedTransaction
+class PerspectiveTransformCmdData : public KisSelectedTransactionData
 {
 public:
-    PerspectiveTransformCmd(KisToolPerspectiveTransform *tool, KisNodeSP node, KisPaintDeviceSP device, KisPaintDeviceSP origDevice,  QPointF topleft, QPointF topright, QPointF bottomleft, QPointF bottomright, KisSelectionSP origSel, QRect initialRect);
-    virtual ~PerspectiveTransformCmd();
+    PerspectiveTransformCmdData(KisToolPerspectiveTransform *tool, KisNodeSP node, KisPaintDeviceSP device, KisPaintDeviceSP origDevice,  QPointF topleft, QPointF topright, QPointF bottomleft, QPointF bottomright, KisSelectionSP origSel, QRect initialRect);
+    virtual ~PerspectiveTransformCmdData();
 
 public:
     virtual void redo();
@@ -86,8 +86,8 @@ private:
     KisPaintDeviceSP m_origDevice;
 };
 
-PerspectiveTransformCmd::PerspectiveTransformCmd(KisToolPerspectiveTransform *tool, KisNodeSP node, KisPaintDeviceSP device, KisPaintDeviceSP origDevice, QPointF topleft, QPointF topright, QPointF bottomleft, QPointF bottomright, KisSelectionSP origSel, QRect initialRect) :
-        KisSelectedTransaction(i18n("Perspective Transform"), node)
+PerspectiveTransformCmdData::PerspectiveTransformCmdData(KisToolPerspectiveTransform *tool, KisNodeSP node, KisPaintDeviceSP device, KisPaintDeviceSP origDevice, QPointF topleft, QPointF topright, QPointF bottomleft, QPointF bottomright, KisSelectionSP origSel, QRect initialRect) :
+        KisSelectedTransactionData(i18n("Perspective Transform"), node)
         , m_initialRect(initialRect)
         , m_topleft(topleft), m_topright(topright), m_bottomleft(bottomleft), m_bottomright(bottomright)
         , m_tool(tool)
@@ -97,11 +97,11 @@ PerspectiveTransformCmd::PerspectiveTransformCmd(KisToolPerspectiveTransform *to
 {
 }
 
-PerspectiveTransformCmd::~PerspectiveTransformCmd()
+PerspectiveTransformCmdData::~PerspectiveTransformCmdData()
 {
 }
 
-void PerspectiveTransformCmd::transformArgs(QPointF &topleft, QPointF &topright, QPointF &bottomleft, QPointF& bottomright) const
+void PerspectiveTransformCmdData::transformArgs(QPointF &topleft, QPointF &topright, QPointF &bottomleft, QPointF& bottomright) const
 {
     topleft = m_topleft;
     topright = m_topright;
@@ -109,33 +109,49 @@ void PerspectiveTransformCmd::transformArgs(QPointF &topleft, QPointF &topright,
     bottomright = m_bottomright;
 }
 
-KisSelectionSP PerspectiveTransformCmd::origSelection(QRect& initialRect) const
+KisSelectionSP PerspectiveTransformCmdData::origSelection(QRect& initialRect) const
 {
     initialRect = m_initialRect;
     return m_origSelection;
 }
 
-void PerspectiveTransformCmd::redo()
+void PerspectiveTransformCmdData::redo()
 {
-    KisSelectedTransaction::redo();
+    KisSelectedTransactionData::redo();
 }
 
-void PerspectiveTransformCmd::undo()
+void PerspectiveTransformCmdData::undo()
 {
-    KisSelectedTransaction::undo();
+    KisSelectedTransactionData::undo();
 }
 
-KisPaintDeviceSP PerspectiveTransformCmd::theDevice()
+KisPaintDeviceSP PerspectiveTransformCmdData::theDevice()
 {
     return m_device;
 }
 
-KisPaintDeviceSP PerspectiveTransformCmd::origDevice()
+KisPaintDeviceSP PerspectiveTransformCmdData::origDevice()
 {
     return m_origDevice;
 }
 }
 
+class PerspectiveTransformCmd : public KisTransaction
+{
+public:
+    PerspectiveTransformCmd(KisToolPerspectiveTransform *tool, KisNodeSP node,
+                            KisPaintDeviceSP device, KisPaintDeviceSP origDevice,
+                            QPointF topleft, QPointF topright,
+                            QPointF bottomleft, QPointF bottomright,
+                            KisSelectionSP origSel, QRect initialRect)
+    {
+        m_transactionData =
+            new PerspectiveTransformCmdData(tool, node, device, origDevice,
+                                            topleft, topright, bottomleft, bottomright,
+                                            origSel, initialRect);
+    }
+};
+
 KisToolPerspectiveTransform::KisToolPerspectiveTransform(KoCanvasBase * canvas)
         : KisTool(canvas, KisCursor::load("tool_perspectivetransform_cursor.png", 6, 6)), m_optWidget(0), m_optForm(0)
 {
@@ -174,10 +190,10 @@ void KisToolPerspectiveTransform::activate(ToolActivation toolActivation, const
     if (image() && currentImage() && currentNode()->paintDevice()) {
         image()->undoAdapter()->setCommandHistoryListener(this);
 
-        const PerspectiveTransformCmd *cmd = 0;
+        const PerspectiveTransformCmdData *cmd = 0;
 
         if (image()->undoAdapter()->presentCommand())
-            cmd = dynamic_cast<const PerspectiveTransformCmd*>(image()->undoAdapter()->presentCommand());
+            cmd = dynamic_cast<const PerspectiveTransformCmdData*>(image()->undoAdapter()->presentCommand());
 
         if (cmd == 0) {
             m_interractionMode = DRAWRECTINTERRACTION;
@@ -624,7 +640,7 @@ void KisToolPerspectiveTransform::transform()
     KoUpdater *progress = updater->startSubtask();
 
     // This mementoes the current state of the active device.
-    PerspectiveTransformCmd * transaction = new PerspectiveTransformCmd(this, currentNode(), currentNode()->paintDevice(), m_origDevice,
+    PerspectiveTransformCmd transaction (this, currentNode(), currentNode()->paintDevice(), m_origDevice,
             m_topleft, m_topright, m_bottomleft, m_bottomright, m_origSelection, m_initialRect);
 
     // Copy the original state back.
@@ -658,8 +674,7 @@ void KisToolPerspectiveTransform::transform()
     /*
         // If canceled, go back to the memento
         if (worker.isCanceled()) {
-            transaction->undo();
-            delete transaction;
+            transaction.revert()
             return;
         }
     */
@@ -668,17 +683,12 @@ void KisToolPerspectiveTransform::transform()
     // Else add the command -- this will have the memento from the previous state,
     // and the transformed state from the original device we cached in our activated()
     // method.
-    if (transaction) {
-        if (currentImage()->undo())
-            currentImage()->undoAdapter()->addCommand(transaction);
-        else
-            delete transaction;
-    }
+    transaction.commit(image()->undoAdapter());
 }
 
 void KisToolPerspectiveTransform::notifyCommandAdded(const QUndoCommand * command)
 {
-    const PerspectiveTransformCmd * cmd = dynamic_cast<const PerspectiveTransformCmd*>(command);
+    const PerspectiveTransformCmdData* cmd = dynamic_cast<const PerspectiveTransformCmdData*>(command);
     if (cmd == 0) {
         // The last added command wasn't one of ours;
         // we should reset to the new state of the canvas.
@@ -691,10 +701,10 @@ void KisToolPerspectiveTransform::notifyCommandAdded(const QUndoCommand * comman
 void KisToolPerspectiveTransform::notifyCommandExecuted(const QUndoCommand * command)
 {
     Q_UNUSED(command);
-    const PerspectiveTransformCmd * cmd = 0;
+    const PerspectiveTransformCmdData* cmd = 0;
 
     if (image()->undoAdapter()->presentCommand())
-        cmd = dynamic_cast<const PerspectiveTransformCmd*>(image()->undoAdapter()->presentCommand());
+        cmd = dynamic_cast<const PerspectiveTransformCmdData*>(image()->undoAdapter()->presentCommand());
 
     if (cmd == 0) {
         // The command now on the top of the stack isn't one of ours
diff --git a/krita/plugins/tools/tool_polygon/kis_tool_polygon.cc b/krita/plugins/tools/tool_polygon/kis_tool_polygon.cc
index f084def..fb8f342 100644
--- a/krita/plugins/tools/tool_polygon/kis_tool_polygon.cc
+++ b/krita/plugins/tools/tool_polygon/kis_tool_polygon.cc
@@ -74,7 +74,7 @@ void KisToolPolygon::finishPolyline(const QVector<QPointF>& points)
 
         if (device) {
             KisPainter painter(device, currentSelection());
-            if (currentImage()->undo()) painter.beginTransaction(i18n("Polygon"));
+            painter.beginTransaction(i18n("Polygon"));
             setupPainter(&painter);
             painter.setOpacity(m_opacity);
             painter.setCompositeOp(m_compositeOp);
@@ -82,7 +82,7 @@ void KisToolPolygon::finishPolyline(const QVector<QPointF>& points)
             device->setDirty(painter.dirtyRegion());
             notifyModified();
 
-            canvas()->addCommand(painter.endTransaction());
+            painter.endTransaction(image()->undoAdapter());
         }
     } else {
         KoPathShape* path = new KoPathShape();
diff --git a/krita/plugins/tools/tool_polyline/kis_tool_polyline.cc b/krita/plugins/tools/tool_polyline/kis_tool_polyline.cc
index 3fe8d97..24f7cba 100644
--- a/krita/plugins/tools/tool_polyline/kis_tool_polyline.cc
+++ b/krita/plugins/tools/tool_polyline/kis_tool_polyline.cc
@@ -89,7 +89,7 @@ void KisToolPolyline::finishPolyline(const QVector<QPointF>& points)
             }
         }
         device->setDirty(painter.dirtyRegion());
-        canvas()->addCommand(painter.endTransaction());
+        painter.endTransaction(image()->undoAdapter());
     } else {
         KoPathShape* path = new KoPathShape();
         path->setShapeId(KoPathShapeId);
diff --git a/krita/plugins/tools/tool_star/kis_tool_star.cc b/krita/plugins/tools/tool_star/kis_tool_star.cc
index 6e910d2..81ccdc5 100644
--- a/krita/plugins/tools/tool_star/kis_tool_star.cc
+++ b/krita/plugins/tools/tool_star/kis_tool_star.cc
@@ -142,7 +142,7 @@ void KisToolStar::mouseReleaseEvent(KoPointerEvent *event)
             notifyModified();
             updatePreview();
 
-            canvas()->addCommand(painter.endTransaction());
+            painter.endTransaction(image()->undoAdapter());
         } else {
             KoPathShape* path = new KoPathShape();
             path->setShapeId(KoPathShapeId);
